import com.urbancode.anthill3.AHPTool
import com.urbancode.anthill3.plugin.rtcscm.RTCHelper


final def workDir = new File('.').canonicalFile
final def ahpTool = new AHPTool();
final def props = ahpTool.getStepProperties();
final def dir = new File(workDir, props['source/dirOffset'] ?: '.').canonicalFile
final def rtcHelper = new RTCHelper(props)

if (!dir.exists()) {
    println("Directory ${dir} does not exist so nothing to cleanup!")
}
else if (dir.isFile()) {
    throw new Exception("Specified working directory ${dir} is a file!")
}
else {
    // try to get the status of the local workspace, if there is none we just need to remove everything
    try {
        rtcHelper.undo(dir)
    }
    catch (Exception e) {
        e.printStackTrace()
        println "No local workspace detected in ${dir}!"
        rtcHelper.cleanup(dir)
    }
}

