import com.urbancode.anthill3.AHPTool
import com.urbancode.anthill3.plugin.rtcscm.RTCHelper

final def ahpTool = new AHPTool();
final def props = ahpTool.getStepProperties();
final def baseline = props['source/baseline'];
final def rtcHelper = new RTCHelper(props)


//create a snapshot if necessary
rtcHelper.createSnapshot()

// try to get the components of the workspace, if we fail we need to create it, if not we need to update it if there
// there are changes to the components/baselines/snapshots
def wsInfo = rtcHelper.getWorkspaceInfo(null)
if (wsInfo.cmdError.length() > 0) {
    if (wsInfo.cmdError.indexOf('Ambiguous') != -1) {
        // this is the case of multiple workspaces with the same name if name and not alias was used
        throw new Exception("More than one workspaces exist for name ${props['source/workspace']}, please remove duplicates or use an alias!")
    }
    else if (wsInfo.cmdError.indexOf('Could not find workspace') != -1) {
        // error was due to a missing workspace
        rtcHelper.createWorkspace()
        wsInfo = rtcHelper.getWorkspaceInfo(null)
        rtcHelper.updateWorkspaceComponents(wsInfo.componentList)
        rtcHelper.changeWorkspaceBaseline()
        rtcHelper.cleanup(null)
        rtcHelper.loadWorkspace()
    }
    else {
        // unknown error
        throw new Exception(wsInfo.cmdError.toString())
    }
}
else {
    rtcHelper.changeWorkspaceFlowStream(wsInfo.workspaceStreamName, wsInfo.workspaceStreamAlias)
    if (!baseline) {
        rtcHelper.changeWorkspaceSnapshot()
    }
    rtcHelper.updateWorkspaceComponents(wsInfo.componentList)
    rtcHelper.changeWorkspaceBaseline()
    try {
        rtcHelper.repair()
        rtcHelper.undo(null)
    }
    catch (Exception e) {
        println "Workspace Repair failed, doing a complete load!"
        rtcHelper.cleanup(null)
        rtcHelper.loadWorkspace()

    }
}

